/*
    Copyright (C) 2021  HisArmMan

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef GAMEMISCH
#define GAMEMISCH
#include <goodbrew/config.h>
#include <goodbrew/controls.h>
#include "assistance.h"
#include "main.h"
enum myextrabuttons{
	BUTTON_LSTICKU=NUMBUTTONS+1,
	BUTTON_LSTICKD=NUMBUTTONS+2,
	BUTTON_LSTICKL=NUMBUTTONS+3,
	BUTTON_LSTICKR=NUMBUTTONS+4,
	BUTTON_RSTICKU=NUMBUTTONS+5,
	BUTTON_RSTICKD=NUMBUTTONS+6,
	BUTTON_RSTICKL=NUMBUTTONS+7,
	BUTTON_RSTICKR=NUMBUTTONS+8,
};
struct boundbutton{
	crossButton* buts;
	int numbuts;
};
int buttonpressed(struct boundbutton* b);
int buttondown(struct boundbutton* b);
void initboundbut(struct boundbutton* b);
void initboundbutdef(struct boundbutton* b, crossButton defaultbutton);
void addboundbut(struct boundbutton* b, crossButton addme);
void freeboundbut(struct boundbutton* b);
///
struct pcontrols{
	struct boundbutton cw;
	struct boundbutton cc;
	struct boundbutton up;
	struct boundbutton down;
	struct boundbutton left;
	struct boundbutton right;
	struct boundbutton place;
	struct boundbutton raisestack;
};
void savecontrols(const char* fpath, struct pcontrols* c, mltime dasdelay, mltime dasrepeat);
void loadcontrols(const char* fpath, struct pcontrols* c, mltime* dasdelay, mltime* dasrepeat);
void controlseditor(struct pcontrols* se);
////////////////////////
struct stampres;
struct stampprops{
	int entirew;
	int entireh;
	int insidew; // offset of inside is (cornerw,cornerw)
	int insideh;
	int cornerw;
	
	int __numedgex;
	int __numedgey;
};
struct stampres* loadstampres();
void freestampres(struct stampres* a);
void calcstamp(struct stampprops* ret, int insidew, int insideh, int cornerw);
void drawstamp(int x, int y, struct stampprops* p, unsigned char a, struct stampres* stampresuncast);
////////////////////////
struct uddas{
	signed char dasdir;
	u64 nextdasshift;
	int upbutton;
	int downbutton;
};
void inituddas(struct uddas* u, char isactuallylr);
int getuddas(struct uddas* m, u64 fTime);
////////////////////////
#define PUMENUINSIDECOLOR 42,0,100
#define PUMENUINNERBORDER 26,0,61
#define PUMENUOUTERBORDER 0,0,0
#define PUMENUOUTERBORDERW (blockw*.05)
struct pumenu{
	char** options;
	int numoptions;
	int choice;
	mltime introtime;
	//
	u64 starttime;
	struct uddas das;
};
int pumenucontrols(struct pumenu* m, u64 fTime);
void initpumenu(struct pumenu* dest);
void drawpumenu(struct pumenu* menu, u64 fTime);
////////////////////////
#define CMENUENTERANIMTIME 500
struct cmenu{
	int numoptions;
	char** labels;
	void** values;
	char* props;
	int choice;
	//
	u64 enterAnimationEnd;
	char isoutro;
	int maxlabelw;
	int maxvaluew;
	struct uddas ddas;
	struct uddas rdas;
};
enum cmenuprops{ // bits
	CMENUPROP_LEFTRIGHT=1,
	CMENUPROP_DISPLAYINT=2,
	CMENUPROP_DISPLAYDOUBLE=4,
	CMENUPROP_DISPLAYBOOL=8,
	CMENUPROP_USERFLAG=16, // for your own purposes
};
void initcmenu(struct cmenu* m, u64 fTime);
void begincmenuoutro(struct cmenu* m, u64 fTime);
void drawcmenu(struct cmenu* m, u64 fTime);
int cmenucontrols(struct cmenu* m, u64 fTime);
void cmenuvaluechange(struct cmenu* m, int i);
void cmenulabelchange(struct cmenu* m, int i);
int cmenuoutrodone(struct cmenu* c, u64 fTime);
int simplecmenu(char** labels, int numlabels, int defaultchoice, void(*extradrawfunc)(struct cmenu*,u64));
////////////////////////
int ruleseteditor(struct gamesettings* se);
#endif
