/*
Copyright (c) 2018 MyLegGuy

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not
   claim that you wrote the original software. If you use this software
   in a product, an acknowledgment in the product documentation would be
   appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
   misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.
*/
#ifndef NLISTHEADERINCLUDED
#define NLISTHEADERINCLUDED

#define ITERATENLIST(_passedStart,_passedCode)					\
	{															\
		if (_passedStart!=NULL){								\
			struct nList* _curnList=_passedStart;				\
			struct nList* _lastnList=NULL;						\
			(void)_lastnList;									\
			struct nList* _cachedNext;							\
			do{													\
				_cachedNext = _curnList->nextEntry;				\
				_passedCode;									\
				_lastnList=_curnList;							\
			}while((_curnList=_cachedNext));					\
		}														\
	}
// use from within ITERATENLIST. removes the current entry and free it.
// note that _curnList is changed to influence the next _lastnList. do not use it after this.
#define ITERATENLISTREMOVETHISONE(headref,freemem) \
{ \
	struct nList* __oldnext=_curnList->nextEntry; \
	freenListEntry(_curnList, freemem); \
	if (_lastnList){ \
		_lastnList->nextEntry=__oldnext; \
		_curnList=_lastnList;\
	}else{ \
		(headref)=__oldnext; \
		_curnList=NULL; \
	} \
}


struct nList{
	struct nList* nextEntry;
	void* data;
};

struct nList* addnList(struct nList** _passed); // add a new entry to the end
void freenList(struct nList* _freeThis, char _freeMemory);
void freenListEntry(struct nList* _freeThis, char _freeMemory);
// Makes an empty node. If you want to make a new list, set your first node to NULL
struct nList* lowNewnList();
int nListLen(struct nList* _passed);
struct nList* getnList(struct nList* _passed, int _index);
struct nList* removenList(struct nList** _removeFrom, int _removeIndex);
struct nList* prependnList(struct nList** _source);
struct nList* insertnList(struct nList** _passedList, int _index);
void appendnList(struct nList** _source, struct nList* _addThis);
// Pass the pointer to your dest list. Store the return value in another variable.
struct nList** initSpeedyAddnList(struct nList** _passedList);
// Pass that thingie returned by initSpeedyAddList and then set it to the return value of this
struct nList** speedyAddnList(struct nList** _nextHolder, void* _desiredData);
struct nList** speedyAddnListEntry(struct nList** _nextHolder, struct nList* _addthis); // alt
// Your temp variable thingie is passed to this
void endSpeedyAddnList(struct nList** _nextHolder);
#endif
