/*
    Copyright (C) 2021  HisArmMan

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef MAINHINCLUDED
#define MAINHINCLUDED
#include <goodbrew/config.h>
#include <goodbrew/sound.h>
#include "assistance.h"
///
#define WRITETHING(thing,thefp) (fwrite(&(thing),sizeof(thing),1,thefp))
#define READTHING(thing,thefp) (fread(&(thing),sizeof(thing),1,thefp))
///
enum stargenmethod{
	STARGEN_EDGES,
	STARGEN_EDGESMIDDLE,
	STARGEN_RANDOM,

	STARGEN_MAX,
};
struct gamesettings{
	int numcolors;
	mltime falltime; // for one tile
	mltime poptime;
	mltime upshiftanimtime;
	int minimumupshiftblocksgenerated;
	mltime playerplacetime;
	mltime timetodie;

	mltime initialupshifttime;
	double delayshortenratio;
	int delayshortentime;

	int defaultboardw;
	int defaultboardh;
	
	int minstars;
	int maxstars;
	int stargen;
	double staraddrarity;
	
	int minblocklen;
	int maxblocklen;

	char doautoupshift;
	char canmanualupshift;
	char isracemode;
	int initialblockgen; // how many

	// internal use for special modes
	char gengarbage;
};
#define DEFAULTDASDELAY 200
#define DEFAULTDASREPEAT 20
//////////////
extern int mainFontHeight;
extern int blockw;
extern crossFont* mainfont;
extern crossTexture* handimg;
extern int maxcolors;
extern mltime preferreddasdelay;
extern mltime preferreddasrepeat;
//////////////
struct gboard;
//////////////
extern crossSE* diesound;
extern crossSE* menuselectsound;
//////////////
#define MINLEVELUPSHIFTTIME 7000 
char menuselectpressed();
double getspeedlv(mltime nextupshift);
void drawbackground();
void getboarddim(struct gboard* board, struct gamesettings* se, int* retw, int* reth);
void getboarddimbysize(struct gamesettings* se, int boardtilew, int boardtileh, int* retw, int *reth);
void WriteToDebugFile(const char* _formatString, ...);
//
#endif
